m4_ifdef([AS_HELP_STRING], , [m4_define([AS_HELP_STRING], m4_defn([AC_HELP_STRING]))])

##
## $Header: /cvsroot/libmage/libMAGE/m4/ac_choose_boost.m4,v 1.9 2004/12/14 01:52:13 zaufi Exp $
##
##
## Copyright (c) 2003, 2004 by Zaufi
##
## AC_CHOOSE_BOOST([REQUIRED_VERSION], [INCLUDE_PATH_HINT], [LIB_PATH_HINT], [ACTION-IF-FOUND, [ACTION-IF-NOT-FOUND]]])
##
## Set the following variables:
##  BOOST_VERSION   - same as defined in boost/version.hpp
##  BOOST_CPPFLAGS  - `-I' preprocessor option
##  BOOST_LDFLAGS   - `-L` linker option
##
AC_DEFUN([AC_CHOOSE_BOOST],[
    ac_choose_boost_result='no'

    am_inc_boost_dir_default=ifelse([$2], , "/usr/include /usr/local/include", $2)
    am_lib_boost_dir_default=ifelse([$3], , "/usr/lib", $3)

    BOOST_CPPFLAGS=''
    BOOST_VERSION=''
    BOOST_LDFLAGS=''

    AC_ARG_WITH(boost_includedir,
      AS_HELP_STRING([--with-boost-includedir=DIR],
        [Use Boost library headers installed at specified path(default=check)]),
      [am_inc_boost_dir=$withval],
      [am_inc_boost_dir=$am_inc_boost_dir_default])
    AC_ARG_WITH(boost_libdir,
      AS_HELP_STRING([--with-boost-libdir=DIR],
        [Use Boost libraries installed at specified path (default=check)]),
      [am_lib_boost_dir=$withval],
      [am_lib_boost_dir=$am_lib_boost_dir_default])

## Check headers
    AC_CACHE_CHECK([where boost headers installed], [ac_cv_boost_headers_installed_at],
        [
        ac_cv_boost_headers_installed_at='not found'
        if test -n "$am_inc_boost_dir"; then
        for dir in $am_inc_boost_dir; do
        if test -f $dir/boost/version.hpp; then
        BOOST_CPPFLAGS="-I$dir"
        ac_cv_boost_headers_installed_at=$dir
        break
        fi
        done
        fi
        ])

## TODO: Fair check libraries needed
    if test $ac_cv_boost_headers_installed_at != 'not found'; then
   ### BOOST_LDFLAGS="-L`dirname $ac_cv_boost_headers_installed_at`/lib"
    BOOST_LDFLAGS="-L$am_lib_boost_dir"
    fi

## Check version
    if test $ac_cv_boost_headers_installed_at != 'not found'; then
    AC_CACHE_CHECK([boost version], [ac_cv_boost_version],
        [
        ac_cv_boost_version=`cat $ac_cv_boost_headers_installed_at/boost/version.hpp \
        | grep  '^# *define  *BOOST_VERSION  *[0-9]\+$' \
        | sed 's,^# *define  *BOOST_VERSION  *\([0-9]\+\)$,\1,'`
        ])
am_required_boost_version=ifelse([$1], , $ac_cv_boost_version, $1)
## Try to compile simple program
  AC_CACHE_CHECK([boost version >= $am_required_boost_version], [ac_cv_boost_version_ok],
      [
      ac_cv_boost_version_ok='no'
      old_CPPFLAGS=$CPPFLAGS
      CPPFLAGS="$CPPFLAGS $BOOST_CPPFLAGS"
      AC_LANG_PUSH(C++)
      AC_COMPILE_IFELSE(
        [
#include <boost/version.hpp>
#if BOOST_VERSION < $am_required_boost_version
#error Boost version less than required
#endif
        ], [ac_cv_boost_version_ok='yes'])
      AC_LANG_POP(C++)
      CPPFLAGS=$old_CPPFLAGS
      ])
  if test $ac_cv_boost_version_ok = 'yes'; then
  BOOST_VERSION=$ac_cv_boost_version
  ac_choose_boost_result='yes'
  fi
  fi

  if test "$ac_choose_boost_result" = 'yes'; then
ifelse([$4], , :, [$4])
  else
ifelse([$5], , :, [$5])
  fi

  AC_SUBST(BOOST_CPPFLAGS)
  AC_SUBST(BOOST_LDFLAGS)
AC_SUBST(BOOST_VERSION)
  ])

AC_DEFUN([AC_DEFINE_DIR], [
      test "x$prefix" = xNONE && prefix="$ac_default_prefix"
      test "x$exec_prefix" = xNONE && exec_prefix='${prefix}'
      ac_define_dir=`eval echo [$]$2`
      ac_define_dir=`eval echo [$]ac_define_dir`
      $1="$ac_define_dir"
      AC_SUBST($1)
      ifelse($3, ,
        AC_DEFINE_UNQUOTED($1, "$ac_define_dir"),
        AC_DEFINE_UNQUOTED($1, "$ac_define_dir", $3))
      ])


dnl ---------------------------------------------------------------------------
dnl Macros for wxWindows detection. Typically used in configure.in as:
dnl
dnl     AC_ARG_ENABLE(...)
dnl     AC_ARG_WITH(...)
dnl        ...
dnl     AM_OPTIONS_WXCONFIG
dnl        ...
dnl        ...
dnl     AM_PATH_WXCONFIG(2.3.4, wxWin=1)
dnl     if test "$wxWin" != 1; then
dnl        AC_MSG_ERROR([
dnl                wxWindows must be installed on your system
dnl                but wx-config script couldn't be found.
dnl
dnl                Please check that wx-config is in path, the directory
dnl                where wxWindows libraries are installed (returned by
dnl                'wx-config --libs' command) is in LD_LIBRARY_PATH or
dnl                equivalent variable and wxWindows version is 2.3.4 or above.
dnl        ])
dnl     fi
dnl     CPPFLAGS="$CPPFLAGS $WX_CPPFLAGS"
dnl     CXXFLAGS="$CXXFLAGS $WX_CXXFLAGS_ONLY"
dnl     CFLAGS="$CFLAGS $WX_CFLAGS_ONLY"
dnl
dnl     LDFLAGS="$LDFLAGS $WX_LIBS"
dnl ---------------------------------------------------------------------------

dnl ---------------------------------------------------------------------------
dnl AM_OPTIONS_WXCONFIG
dnl
dnl adds support for --wx-prefix, --wx-exec-prefix, --with-wxdir and
dnl --wx-config command line options
dnl ---------------------------------------------------------------------------

AC_DEFUN([AM_OPTIONS_WXCONFIG],
[
    AC_ARG_WITH(wxdir,
                [  --with-wxdir=PATH       Use uninstalled version of wxWindows in PATH],
                [ wx_config_name="$withval/wx-config"
                  wx_config_args="--inplace"])
    AC_ARG_WITH(wx-config,
                [  --with-wx-config=CONFIG wx-config script to use (optional)],
                wx_config_name="$withval" )
    AC_ARG_WITH(wx-prefix,
                [  --with-wx-prefix=PREFIX Prefix where wxWindows is installed (optional)],
                wx_config_prefix="$withval", wx_config_prefix="")
    AC_ARG_WITH(wx-exec-prefix,
                [  --with-wx-exec-prefix=PREFIX
                          Exec prefix where wxWindows is installed (optional)],
                wx_config_exec_prefix="$withval", wx_config_exec_prefix="")
])

dnl ---------------------------------------------------------------------------
dnl AM_PATH_WXCONFIG(VERSION, [ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND
dnl                  [, WX-LIBS [, ADDITIONAL-WX-CONFIG-FLAGS]]]])
dnl
dnl Test for wxWindows, and define WX_C*FLAGS, WX_LIBS and WX_LIBS_STATIC
dnl (the latter is for static linking against wxWindows). Set WX_CONFIG_NAME
dnl environment variable to override the default name of the wx-config script
dnl to use. Set WX_CONFIG_PATH to specify the full path to wx-config - in this
dnl case the macro won't even waste time on tests for its existence.
dnl
dnl Optional WX-LIBS argument contains comma- or space-separated list of
dnl wxWindows libraries to link against (it may include contrib libraries). If
dnl it is not specified then WX_LIBS and WX_LIBS_STATIC will contain flags to
dnl link with all of the core wxWindows libraries.
dnl
dnl Optional ADDITIONAL-WX-CONFIG-FLAGS argument is appended to wx-config
dnl invocation command in present. It can be used to fine-tune lookup of
dnl best wxWidgets build available.
dnl
dnl Example use:
dnl   AM_PATH_WXCONFIG([2.6.0], [wxWin=1], [wxWin=0], [html,core,net]
dnl                    [--unicode --debug])
dnl ---------------------------------------------------------------------------

dnl
dnl Get the cflags and libraries from the wx-config script
dnl
AC_DEFUN([AM_PATH_WXCONFIG],
[
  dnl do we have wx-config name: it can be wx-config or wxd-config or ...
  if test x${WX_CONFIG_NAME+set} != xset ; then
     WX_CONFIG_NAME=wx-config
  fi

  if test "x$wx_config_name" != x ; then
     WX_CONFIG_NAME="$wx_config_name"
  fi

  dnl deal with optional prefixes
  if test x$wx_config_exec_prefix != x ; then
     wx_config_args="$wx_config_args --exec-prefix=$wx_config_exec_prefix"
     WX_LOOKUP_PATH="$wx_config_exec_prefix/bin"
  fi
  if test x$wx_config_prefix != x ; then
     wx_config_args="$wx_config_args --prefix=$wx_config_prefix"
     WX_LOOKUP_PATH="$WX_LOOKUP_PATH:$wx_config_prefix/bin"
  fi

  dnl don't search the PATH if WX_CONFIG_NAME is absolute filename
  if test -x "$WX_CONFIG_NAME" ; then
     AC_MSG_CHECKING(for wx-config)
     WX_CONFIG_PATH="$WX_CONFIG_NAME"
     AC_MSG_RESULT($WX_CONFIG_PATH)
  else
     AC_PATH_PROG(WX_CONFIG_PATH, $WX_CONFIG_NAME, no, "$WX_LOOKUP_PATH:$PATH")
  fi

  if test "$WX_CONFIG_PATH" != "no" ; then
    WX_VERSION=""
    no_wx=""

    min_wx_version=ifelse([$1], ,2.2.1,$1)
    if test -z "$5" ; then
      AC_MSG_CHECKING([for wxWindows version >= $min_wx_version])
    else
      AC_MSG_CHECKING([for wxWindows version >= $min_wx_version ($5)])
    fi

    WX_CONFIG_WITH_ARGS="$WX_CONFIG_PATH $wx_config_args $5 $4"

    WX_VERSION=`$WX_CONFIG_WITH_ARGS --version 2>/dev/null`
    wx_config_major_version=`echo $WX_VERSION | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
    wx_config_minor_version=`echo $WX_VERSION | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\2/'`
    wx_config_micro_version=`echo $WX_VERSION | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\3/'`

    wx_requested_major_version=`echo $min_wx_version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
    wx_requested_minor_version=`echo $min_wx_version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\2/'`
    wx_requested_micro_version=`echo $min_wx_version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\3/'`

    wx_ver_ok=""
    if test "x$WX_VERSION" != x ; then
      if test $wx_config_major_version -gt $wx_requested_major_version; then
        wx_ver_ok=yes
      else
        if test $wx_config_major_version -eq $wx_requested_major_version; then
           if test $wx_config_minor_version -gt $wx_requested_minor_version; then
              wx_ver_ok=yes
           else
              if test $wx_config_minor_version -eq $wx_requested_minor_version; then
                 if test $wx_config_micro_version -ge $wx_requested_micro_version; then
                    wx_ver_ok=yes
                 fi
              fi
           fi
        fi
      fi
    fi

    if test "x$wx_ver_ok" = x ; then
      no_wx=yes
    else
      WX_LIBS=`$WX_CONFIG_WITH_ARGS --libs`
      WX_LIBS_STATIC=`$WX_CONFIG_WITH_ARGS --static --libs`

      dnl starting with version 2.2.6 wx-config has --cppflags argument
      wx_has_cppflags=""
      if test $wx_config_major_version -gt 2; then
        wx_has_cppflags=yes
      else
        if test $wx_config_major_version -eq 2; then
           if test $wx_config_minor_version -gt 2; then
              wx_has_cppflags=yes
           else
              if test $wx_config_minor_version -eq 2; then
                 if test $wx_config_micro_version -ge 6; then
                    wx_has_cppflags=yes
                 fi
              fi
           fi
        fi
      fi

      if test "x$wx_has_cppflags" = x ; then
         dnl no choice but to define all flags like CFLAGS
         WX_CFLAGS=`$WX_CONFIG_WITH_ARGS --cflags`
         WX_CPPFLAGS=$WX_CFLAGS
         WX_CXXFLAGS=$WX_CFLAGS

         WX_CFLAGS_ONLY=$WX_CFLAGS
         WX_CXXFLAGS_ONLY=$WX_CFLAGS
      else
         dnl we have CPPFLAGS included in CFLAGS included in CXXFLAGS
         WX_CPPFLAGS=`$WX_CONFIG_WITH_ARGS --cppflags`
         WX_CXXFLAGS=`$WX_CONFIG_WITH_ARGS --cxxflags`
         WX_CFLAGS=`$WX_CONFIG_WITH_ARGS --cflags`

         WX_CFLAGS_ONLY=`echo $WX_CFLAGS | sed "s@^$WX_CPPFLAGS *@@"`
         WX_CXXFLAGS_ONLY=`echo $WX_CXXFLAGS | sed "s@^$WX_CFLAGS *@@"`
      fi
    fi

    if test "x$no_wx" = x ; then
       AC_MSG_RESULT(yes (version $WX_VERSION))
       ifelse([$2], , :, [$2])
    else
       if test "x$WX_VERSION" = x; then
          dnl no wx-config at all
          AC_MSG_RESULT(no)
       else
          AC_MSG_RESULT(no (version $WX_VERSION is not new enough))
       fi

       WX_CFLAGS=""
       WX_CPPFLAGS=""
       WX_CXXFLAGS=""
       WX_LIBS=""
       WX_LIBS_STATIC=""
       ifelse([$3], , :, [$3])
    fi
  fi

  AC_SUBST(WX_CPPFLAGS)
  AC_SUBST(WX_CFLAGS)
  AC_SUBST(WX_CXXFLAGS)
  AC_SUBST(WX_CFLAGS_ONLY)
  AC_SUBST(WX_CXXFLAGS_ONLY)
  AC_SUBST(WX_LIBS)
  AC_SUBST(WX_LIBS_STATIC)
  AC_SUBST(WX_VERSION)
])


